﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PLCS7
{
    /// <summary>
    /// 终端数据块结构体
    /// </summary>
    public struct TerminalStru
    {
        public short terminalID;
        public short terminalStatus;//终端写入
        public short btnStatus;//终端写入
        public int licenseCodeA;//终端写入
        public int licenseCodeB;//终端写入
        public int licenseCodeC;//终端写入
        public int receiptNum;//终端写入
        public short paymentStatus;//中控写入,22
        public short licVerification;//中控写入
        public short parkingFee;//中控写入
        public short userType;//中控写入
        public short coordX;//PLC
        public short coordY;//PLC
        public short groundStatus;

        public override string ToString()
        {
            return "[" + terminalID + "," + terminalStatus + "," + btnStatus + "," + licenseCodeA + "," + licenseCodeB + "," + licenseCodeC + "," + receiptNum + "," + paymentStatus
                + "," + licVerification + "," + parkingFee + "," + userType + "," + groundStatus + "]";
        }
    }

    /// <summary>
    /// 中控与PLC交互使用数据块的结构体
    /// </summary>
    public struct MainBlockStru
    {
        public short terminalID;
        public short numMachineLaunch;
        public short sweepLaserLaunch;
        public short wheelbaseLaserLaunch;
        public short scram;
        public short ready;
        public short parkingRunning;
        public short fetchingRunning;
        public short sweepLaserStatus;
        public short licenseReceived;//中控可写
        public short localAutoMode;
        public short remoteMode;
        public short localManualMode;
        public short processStopped;
        public short groundAStatus;
        public short groundBStatus;
        public short groundCStatus;
        public short arriveAAndOpen;
        public short arriveBAndOpen;
        public short arriveCAndOpen;
        public short leaveAAndOpen;
        public short leaveBAndOpen;
        public short leaveCAndOpen;
        public short processCompleted;
    }

    /// <summary>
    /// 车位单元结构体
    /// </summary>
    public struct ParkingSpaceStru
    {
        public short parkingSpace;
        public short length;
        public short width;
        public short height;
        public short floorNo;
        public short coordX;
        public short coordY;
        public int receiptNum;
        public short spaceStatus;
        public short frontWheelbase;
        public short rearWheelbase;

        public override string ToString()
        {
            return "[" + parkingSpace + "," + length + "," + width + "," + height + "," + floorNo + "," + coordX + "," + coordY + "," + receiptNum
                + "," + spaceStatus + "," + frontWheelbase + "," + rearWheelbase + "]";
        }
    }
}
